#include <PalmOS.h>
#include <NetMgr.h>
#include <unix_stdarg.h> 


#define CRID						'PpGc'

#define MAX_RECV_SIZE				16384
#define MAX_RECV_TIME				10		//10 sec

	//the domain
#define DOMAIN	"www.grandcentral.com"

	//length of data, data
#define REQ1 	"POST /account/login_from_flash/ HTTP/1.1\r\n" 			\
				"Host: " DOMAIN "\r\n"									\
				"Accept-Encoding: */*\r\n"								\
				"Referer: http://" DOMAIN "\r\n"						\
				"Connection: keep-alive\r\n"							\
				"Content-Length: %lu\r\n"								\
				"Content-Type: application/x-www-form-urlencoded\r\n"	\
				"\r\n%s"


	//password, email
#define DATA1	"remember_me=0&login_password=%s&login_id=%s"


	//a_t, to#, from#, cookies
#define REQ2	"GET /calls/send_call_request?a_t=%s&category_id="		\
					"undefined&contact_id=undefined&calltype=call&"		\
					"destno=%s&ani=%s HTTP/1.1\r\n"						\
				"Host: " DOMAIN "\r\n"									\
				"Accept-Encoding: */*\r\n"								\
				"Referer: http://" DOMAIN "\r\n"						\
				"Connection: keep-alive\r\n"							\
				"Cookie: %s\r\n\r\n"


#define N2S2(a)			#a
#define N2S(a)			N2S2(a)
#define ERR_HANDLE(m)	if(e) ErrAlertCustom(e,NULL,NULL,__FILE__ ":" N2S(__LINE__) " => Error " m); else


Boolean getNumber(char** email,char** pass,char** myNum,char** theirNum);




Err netLibOpen(UInt16* libRef){
	
	Err err;
	UInt16 ifErr;
	
	err = SysLibFind("Net.lib", libRef);
	if(err){
		
		err = SysLibLoad(sysFileTLibrary, sysFileCNet, libRef);
	}
	
	if(!err){
		
		err = NetLibOpen(*libRef,&ifErr);
	}
	
	return err;
}

Err netLibClose(UInt16 libRef){
	
	Err ret = NetLibClose(libRef,false);
	
	if(ret == netErrStillOpen) ret = errNone;
	
	return ret;
}

char* formattedStr(const char* formatStr,...){
	
	va_list args;
	char* str;
	Int16 ret;
	
	str = MemPtrNew(16384);
	if(!str) return NULL;
	
	va_start(args, formatStr);
	ret = StrVPrintF(str, formatStr, args);
	va_end(args);
	
	if(ret < 0) return NULL;
	
	ret++;
	
	MemPtrResize(str,ret);
	
	return str;
}

char* getAtToken(const char* data){
	
	const char lookingFor[] = "a_t=";
	const UInt32 lookingForSz = sizeof(lookingFor) - 1;
	const char* found = NULL;
	char* ret;
	UInt32 i,L;
	
	L = StrLen(data);
	
	if(L < lookingForSz) return NULL;
	
	L -= lookingForSz;
	
	for(i = 0; i < L; i++){
		
		if(MemCmp(data + i,lookingFor,lookingForSz) == 0 && data[i + lookingForSz] != ';'){
			
			found = data + i;
			break;
		}
	}
	
	if(!found) return NULL;
	
	found += 4;
	
	L = StrLen(found);
	
	for(i = 0; i < L; i++){
		
		if(found[i] == ';'){
			
			L = i;
			break;
		}
	}
	
	ret = MemPtrNew(L + 1);
	MemMove(ret,found,L);
	ret[L] = 0;
	
	return ret;
}

char* getCookies(char* data){
	
	const char cookieHdr[] = "Set-Cookie: ";
	const UInt32 cookieHdrLen = sizeof(cookieHdr) - 1;
	char *d, *s, c;
	UInt32 i,j,t,num = 1;
	Boolean fakeEnd;
	char** key;
	char** val;
	
	//replace all \r\n with \0, count the occurences
	d = s = data;
	do{
		
		fakeEnd = false;
		c = *s++;
		
		if(c == '\n'){
			
			num++;
			c = 0;
			fakeEnd = true;
		}
		
		if(c == '\r'){
			
			//nothing
		}
		else{
			
			*d++ = c;
		}
		
	}while(c || fakeEnd);
	
	s = data;
	
	key = MemPtrNew(num * sizeof(char*));
	val = MemPtrNew(num * sizeof(char*));
	
	for(j = 0, i = 0; i < num && StrLen(s); i++, s += StrLen(s) + 1){
		
		if(StrNCaselessCompare(s,cookieHdr,cookieHdrLen) == 0){
			
			char *k,*v,*e;
			Boolean found = false;
			
			k = s + cookieHdrLen;
			
			v = k;
			while(*v && *v != '=') v++;
			if(!*v) continue;
			*v++ = 0;
			
			e = v;
			while(*e && *e != ';') e++;
			if(!*e) continue;
			*e++ = 0;
			
			s = e;
			
			for(t = 0; t < j; t++){
				
				if(!StrCompare(key[t],k)){	//later occurences are the useful ones
					
					val[t] = v;
					found = true;
				}
			}
			
			if(!found){
				
				key[j] = k;
				val[j] = v;
				j++;
			}
		}
	}
	
	t = 1;	//NULL terminator
	
	for(i = 0; i < j; i++){
	
		t += StrLen(key[i]) + StrLen(val[i]) + 1;
	}
	
	if(j) t += j - 1;	//separators
	
	s = MemPtrNew(t);
	if(!s) return NULL;
	
	s[0] = 0;
	
	for(i = 0; i < j; i++){
	
		if(i) StrCat(s,";");
		StrCat(s,key[i]);
		StrCat(s,"=");
		StrCat(s,val[i]);
	}
	
	return s;
}

Err netLibRecvHttpPacket(UInt16 libRef, NetSocketRef s,char** str){
	
	UInt32 startTime = TimGetSeconds();
	UInt32 left = MAX_RECV_SIZE - 1;
	UInt16 fromSz;
	char* buf, *c;
	Int16 ret;
	Err e;
	
	*str = NULL;
	
	buf = MemPtrNew(MAX_RECV_SIZE);
	if(!buf) return memErrNotEnoughSpace;
	
	c = buf;
	
	do{
		
		fromSz = 0;
		ret = NetLibReceive(libRef, s, c, left, 0, NULL, &fromSz, 200, &e);
		
		if(ret > 0 || (!ret && (c == buf))){
			
			c += ret;
			left -= ret;
		}
		else if(c - buf){
			
			*c++ = 0;
			
			MemPtrResize(buf,c - buf);
			
			*str = buf;
			
			return errNone;
		}
		else{
			
			MemPtrFree(buf);
			return e?e:netErrGMANState;
		}
		
	}while(TimGetSeconds() - startTime < MAX_RECV_TIME);
	
	return netErrTimeout;
}

Err netLibSendStr(UInt16 libRef, NetSocketRef s, const char* str){
	
	UInt32 L = StrLen(str);
	Int16 ret;
	Err e;
	
	do{
		
		ret = NetLibSend(libRef,s,(void*)str,L,0,NULL,0,-1,&e);
		
		if(ret <= 0) return e;
		
		L -= ret;
		str += ret;
		
	}while(L);
	
	return errNone;
}

UInt32 PilotMain(UInt16 cmd,void* cmdPBP,UInt16 flags){
	
	if(cmd == 0){
		
		Err e;
		UInt16 libRef;
		NetSocketRef s;
		NetSocketAddrINType addr;
		NetHostInfoBufType buf;
		NetHostInfoPtr dnsLookupResult;
		Int16 ret;
		char *str1, *str2, *str3;
		char *email, *password, *myNum, *theirNum;
	
		if(getNumber(&email,&password,&myNum,&theirNum)){
			
			e = netLibOpen(&libRef);
			ERR_HANDLE("opening netlib"){
				
				s = NetLibSocketOpen(libRef,netSocketAddrINET,netSocketTypeStream,netSocketProtoIPTCP,1000,&e);
				ERR_HANDLE("opening a socket"){
					
					dnsLookupResult = NetLibGetHostByName(libRef,DOMAIN,&buf,1000,&e);
					ERR_HANDLE("doing the DNS lookup"){
						
						if(dnsLookupResult && dnsLookupResult->addrLen){
							
							addr.family = netSocketAddrINET;
							addr.port = 80;
							addr.addr = buf.address[0];
							
							ret = NetLibSocketConnect(libRef,s,(NetSocketAddrType*)&addr,sizeof(addr),5000,&e);
							ERR_HANDLE("connecting"){
								
								str1 = formattedStr(DATA1,password,email);
								str2 = formattedStr(REQ1,(UInt32)StrLen(str1),str1);
								MemPtrFree(str1);
								
								e = netLibSendStr(libRef,s,str2);
								MemPtrFree(str2);
								
								ERR_HANDLE("sending POST"){
									
									e = netLibRecvHttpPacket(libRef,s,&str1);
									ERR_HANDLE("receiving tokens"){
										
										str2 = getAtToken(str1);
										str3 = getCookies(str1);
										MemPtrFree(str1);
										
										if(str2 && str3){
											
											str1 = formattedStr(REQ2,str2,theirNum,myNum,str3);
											
											e = netLibSendStr(libRef,s,str1);
											ERR_HANDLE("sending GET"){
												
												e = netLibRecvHttpPacket(libRef,s,&str2);
												ERR_HANDLE("receiving results"){
													
													str1 = StrStr(str2," 200 OK\r\n");
													
													if(str1){
														
														FrmCustomAlert(10024,"Dial succeeded.",NULL,NULL);
													}
													else{
														
														ErrAlertCustom(0,"Failed to dial!",NULL,NULL);
													}
													
													MemPtrFree(str2);
												}
											}
										}
										else{
											
											if(str2) MemPtrFree(str2);
											if(str3) MemPtrFree(str3);
											
											ErrAlertCustom(0,"Cannot get data",NULL,NULL);
										}
									}
								}
							}
						}else ErrAlertCustom(0,"DNS lookup failed",NULL,NULL);
					}
					
					e = NetLibSocketClose(libRef,s,0,&e);
					ERR_HANDLE("closing socket");
				}
				
				e = netLibClose(libRef);
				ERR_HANDLE("closing netlib");
			}
			
			MemPtrFree(email);
			MemPtrFree(password);
			MemPtrFree(myNum);
			MemPtrFree(theirNum);
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//                               The UI code                               //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

typedef struct{
	
	char email[64];
	char pass[32];
	char myNum[12];
	char dialedNum[12];
	
}Prefs;

void setPrefs(Prefs* p){
	
	PrefSetAppPreferences(CRID,0,0,p,sizeof(Prefs),false);
}

void getPrefs(Prefs* p){
	
	Int16 ret;
	UInt16 sz = sizeof(Prefs);
	
	ret = PrefGetAppPreferences(CRID,0,p,&sz,false);
	
	if(ret == noPreferenceFound){
		
		MemSet(p,sizeof(Prefs),0);
		
		setPrefs(p);
	}
}

void* FrmGetObjPtr(FormPtr fp,UInt16 id){
	
	FrmGetObjectPtr(fp,FrmGetObjectIndex(fp,id));
}

MemHandle txtToHandle(char* c){
	
	MemHandle mh = MemHandleNew(StrLen(c) + 1);
	
	if(!mh) SysFatalAlert("Cannot copy text to a handle");
	
	StrCopy(MemHandleLock(mh),c);
	MemHandleUnlock(mh);
	
	return mh;
}

char* strdup(const char* str){
	
	char* d = MemPtrNew(StrLen(str) + 1);
	
	if(!d) SysFatalAlert("Cannot copy text to a pointer");
	
	StrCopy(d,str);
	
	return d;
}

void editPrefs(){
	
	Prefs* p;
	FormPtr fp;
	MemHandle emailH,passH,numH;
	FieldPtr fEmail,fPass,fNum;
	
	p = MemPtrNew(sizeof(Prefs));
	if(!p) return;
	
	getPrefs(p);
	
	emailH = txtToHandle(p->email);
	passH = txtToHandle(p->pass);
	numH = txtToHandle(p->myNum);
	
	fp = FrmInitForm(1001);
	
	fEmail = FrmGetObjPtr(fp,1000);
	fPass = FrmGetObjPtr(fp,1001);
	fNum = FrmGetObjPtr(fp,1002);
	
	FldSetTextHandle(fEmail,emailH);
	FldSetTextHandle(fPass,passH);
	FldSetTextHandle(fNum,numH);
	
	FrmDoDialog(fp);
	
	FldSetTextHandle(fEmail,NULL);
	FldSetTextHandle(fPass,NULL);
	FldSetTextHandle(fNum,NULL);
	
	FrmDeleteForm(fp);
	
	StrCopy(p->email,MemHandleLock(emailH)); MemHandleUnlock(emailH); MemHandleFree(emailH);
	StrCopy(p->pass,MemHandleLock(passH)); MemHandleUnlock(passH); MemHandleFree(passH);
	StrCopy(p->myNum,MemHandleLock(numH)); MemHandleUnlock(numH); MemHandleFree(numH);
	
	setPrefs(p);
	
	MemPtrFree(p);
}

Boolean prefsInited(Prefs* p){
	
	return StrLen(p->pass) && StrLen(p->email) && StrStr(p->email,"@") && StrLen(p->myNum) == 10;
}

Boolean mainFormHandler(EventPtr e){
	
	if(e->eType == ctlSelectEvent){
		
		UInt16 id = e->data.ctlSelect.controlID;
		
		if(id == 9000){
			
			MemHandle mh;
			
			mh = FldGetTextHandle(FrmGetObjPtr(FrmGetFormPtr(1000),2000));
			if(StrLen(MemHandleLock(mh)) != 10){
				
				ErrAlertCustom(0,"Number should be 10 digits long",NULL,NULL);
				MemHandleUnlock(mh);
				return true;
			}
			else{
				
				MemHandleUnlock(mh);
			}
		}
		else if(id == 4000){
			
			editPrefs();
			return true;
		}
	}
	return false;
}

Boolean getNumber(char** email,char** pass,char** myNum,char** theirNum){
	
	Prefs* p;
	FormPtr fp;
	UInt16 btn = 0;
	MemHandle numberH;
	char* numberP;
	FieldPtr fi;
	
	p = MemPtrNew(sizeof(Prefs));
	if(!p) return false;
	
	getPrefs(p);
	
	numberH = txtToHandle(p->dialedNum);
	
	fp = FrmInitForm(1000);
	fi = FrmGetObjPtr(fp,2000);
	FldSetTextHandle(fi,numberH);
	FrmSetEventHandler(fp,&mainFormHandler);
	
redo:
		
	btn = FrmDoDialog(fp);
	getPrefs(p);
	
	if(btn == 9000 && !prefsInited(p)){
		
		ErrAlertCustom(0,"You need to enter account settings before dialing",NULL,NULL);
		goto redo;
	}
	
	FldSetTextHandle(fi,NULL);
	FrmDeleteForm(fp);
	
	numberP = MemHandleLock(numberH);
	getPrefs(p);
	StrCopy(p->dialedNum,numberP);
	setPrefs(p);
	MemHandleUnlock(numberH);
	MemHandleFree(numberH);
	
	if(btn == 9000){
		
		*email = strdup(p->email);
		*pass = strdup(p->pass);
		*myNum = strdup(p->myNum);
		*theirNum = strdup(p->dialedNum);
	}
	
	MemPtrFree(p);
	
	return btn == 9000;
}






